Index: lemon/network_simplex.h
===================================================================
--- lemon/network_simplex.h	(revision 835)
+++ lemon/network_simplex.h	(revision 690)
@@ -20,5 +20,5 @@
 #define LEMON_NETWORK_SIMPLEX_H
 
-/// \ingroup min_cost_flow_algs
+/// \ingroup min_cost_flow
 ///
 /// \file
@@ -34,5 +34,5 @@
 namespace lemon {
 
-  /// \addtogroup min_cost_flow_algs
+  /// \addtogroup min_cost_flow
   /// @{
 
@@ -41,7 +41,5 @@
   ///
   /// \ref NetworkSimplex implements the primal Network Simplex algorithm
-  /// for finding a \ref min_cost_flow "minimum cost flow"
-  /// \ref amo93networkflows, \ref dantzig63linearprog,
-  /// \ref kellyoneill91netsimplex.
+  /// for finding a \ref min_cost_flow "minimum cost flow".
   /// This algorithm is a specialized version of the linear programming
   /// simplex method directly for the minimum cost flow problem.
@@ -51,5 +49,5 @@
   /// in LEMON for the minimum cost flow problem.
   /// Moreover it supports both directions of the supply/demand inequality
-  /// constraints. For more information, see \ref SupplyType.
+  /// constraints. For more information see \ref SupplyType.
   ///
   /// Most of the parameters of the problem (except for the digraph)
@@ -60,7 +58,7 @@
   /// \tparam GR The digraph type the algorithm runs on.
   /// \tparam V The value type used for flow amounts, capacity bounds
-  /// and supply values in the algorithm. By default, it is \c int.
+  /// and supply values in the algorithm. By default it is \c int.
   /// \tparam C The value type used for costs and potentials in the
-  /// algorithm. By default, it is the same as \c V.
+  /// algorithm. By default it is the same as \c V.
   ///
   /// \warning Both value types must be signed and all input data must
@@ -69,5 +67,5 @@
   /// \note %NetworkSimplex provides five different pivot rule
   /// implementations, from which the most efficient one is used
-  /// by default. For more information, see \ref PivotRule.
+  /// by default. For more information see \ref PivotRule.
   template <typename GR, typename V = int, typename C = V>
   class NetworkSimplex
@@ -105,14 +103,48 @@
     /// constraints of the \ref min_cost_flow "minimum cost flow problem".
     ///
-    /// The default supply type is \c GEQ, the \c LEQ type can be
-    /// selected using \ref supplyType().
-    /// The equality form is a special case of both supply types.
+    /// The default supply type is \c GEQ, since this form is supported
+    /// by other minimum cost flow algorithms and the \ref Circulation
+    /// algorithm, as well.
+    /// The \c LEQ problem type can be selected using the \ref supplyType()
+    /// function.
+    ///
+    /// Note that the equality form is a special case of both supply types.
     enum SupplyType {
+
       /// This option means that there are <em>"greater or equal"</em>
-      /// supply/demand constraints in the definition of the problem.
+      /// supply/demand constraints in the definition, i.e. the exact
+      /// formulation of the problem is the following.
+      /**
+          \f[ \min\sum_{uv\in A} f(uv) \cdot cost(uv) \f]
+          \f[ \sum_{uv\in A} f(uv) - \sum_{vu\in A} f(vu) \geq
+              sup(u) \quad \forall u\in V \f]
+          \f[ lower(uv) \leq f(uv) \leq upper(uv) \quad \forall uv\in A \f]
+      */
+      /// It means that the total demand must be greater or equal to the 
+      /// total supply (i.e. \f$\sum_{u\in V} sup(u)\f$ must be zero or
+      /// negative) and all the supplies have to be carried out from 
+      /// the supply nodes, but there could be demands that are not 
+      /// satisfied.
       GEQ,
+      /// It is just an alias for the \c GEQ option.
+      CARRY_SUPPLIES = GEQ,
+
       /// This option means that there are <em>"less or equal"</em>
-      /// supply/demand constraints in the definition of the problem.
-      LEQ
+      /// supply/demand constraints in the definition, i.e. the exact
+      /// formulation of the problem is the following.
+      /**
+          \f[ \min\sum_{uv\in A} f(uv) \cdot cost(uv) \f]
+          \f[ \sum_{uv\in A} f(uv) - \sum_{vu\in A} f(vu) \leq
+              sup(u) \quad \forall u\in V \f]
+          \f[ lower(uv) \leq f(uv) \leq upper(uv) \quad \forall uv\in A \f]
+      */
+      /// It means that the total demand must be less or equal to the 
+      /// total supply (i.e. \f$\sum_{u\in V} sup(u)\f$ must be zero or
+      /// positive) and all the demands have to be satisfied, but there
+      /// could be supplies that are not carried out from the supply
+      /// nodes.
+      LEQ,
+      /// It is just an alias for the \c LEQ option.
+      SATISFY_DEMANDS = LEQ
     };
     
@@ -125,21 +157,21 @@
     /// implementations that significantly affect the running time
     /// of the algorithm.
-    /// By default, \ref BLOCK_SEARCH "Block Search" is used, which
+    /// By default \ref BLOCK_SEARCH "Block Search" is used, which
     /// proved to be the most efficient and the most robust on various
     /// test inputs according to our benchmark tests.
-    /// However, another pivot rule can be selected using the \ref run()
+    /// However another pivot rule can be selected using the \ref run()
     /// function with the proper parameter.
     enum PivotRule {
 
-      /// The \e First \e Eligible pivot rule.
+      /// The First Eligible pivot rule.
       /// The next eligible arc is selected in a wraparound fashion
       /// in every iteration.
       FIRST_ELIGIBLE,
 
-      /// The \e Best \e Eligible pivot rule.
+      /// The Best Eligible pivot rule.
       /// The best eligible arc is selected in every iteration.
       BEST_ELIGIBLE,
 
-      /// The \e Block \e Search pivot rule.
+      /// The Block Search pivot rule.
       /// A specified number of arcs are examined in every iteration
       /// in a wraparound fashion and the best eligible arc is selected
@@ -147,5 +179,5 @@
       BLOCK_SEARCH,
 
-      /// The \e Candidate \e List pivot rule.
+      /// The Candidate List pivot rule.
       /// In a major iteration a candidate list is built from eligible arcs
       /// in a wraparound fashion and in the following minor iterations
@@ -153,5 +185,5 @@
       CANDIDATE_LIST,
 
-      /// The \e Altering \e Candidate \e List pivot rule.
+      /// The Altering Candidate List pivot rule.
       /// It is a modified version of the Candidate List method.
       /// It keeps only the several best eligible arcs from the former
@@ -164,4 +196,6 @@
     TEMPLATE_DIGRAPH_TYPEDEFS(GR);
 
+    typedef std::vector<Arc> ArcVector;
+    typedef std::vector<Node> NodeVector;
     typedef std::vector<int> IntVector;
     typedef std::vector<bool> BoolVector;
@@ -182,6 +216,4 @@
     int _node_num;
     int _arc_num;
-    int _all_arc_num;
-    int _search_arc_num;
 
     // Parameters of the problem
@@ -246,5 +278,5 @@
       const CostVector &_pi;
       int &_in_arc;
-      int _search_arc_num;
+      int _arc_num;
 
       // Pivot rule data
@@ -257,6 +289,5 @@
         _source(ns._source), _target(ns._target),
         _cost(ns._cost), _state(ns._state), _pi(ns._pi),
-        _in_arc(ns.in_arc), _search_arc_num(ns._search_arc_num),
-        _next_arc(0)
+        _in_arc(ns.in_arc), _arc_num(ns._arc_num), _next_arc(0)
       {}
 
@@ -264,5 +295,5 @@
       bool findEnteringArc() {
         Cost c;
-        for (int e = _next_arc; e < _search_arc_num; ++e) {
+        for (int e = _next_arc; e < _arc_num; ++e) {
           c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
           if (c < 0) {
@@ -298,5 +329,5 @@
       const CostVector &_pi;
       int &_in_arc;
-      int _search_arc_num;
+      int _arc_num;
 
     public:
@@ -306,5 +337,5 @@
         _source(ns._source), _target(ns._target),
         _cost(ns._cost), _state(ns._state), _pi(ns._pi),
-        _in_arc(ns.in_arc), _search_arc_num(ns._search_arc_num)
+        _in_arc(ns.in_arc), _arc_num(ns._arc_num)
       {}
 
@@ -312,5 +343,5 @@
       bool findEnteringArc() {
         Cost c, min = 0;
-        for (int e = 0; e < _search_arc_num; ++e) {
+        for (int e = 0; e < _arc_num; ++e) {
           c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
           if (c < min) {
@@ -337,5 +368,5 @@
       const CostVector &_pi;
       int &_in_arc;
-      int _search_arc_num;
+      int _arc_num;
 
       // Pivot rule data
@@ -349,13 +380,12 @@
         _source(ns._source), _target(ns._target),
         _cost(ns._cost), _state(ns._state), _pi(ns._pi),
-        _in_arc(ns.in_arc), _search_arc_num(ns._search_arc_num),
-        _next_arc(0)
+        _in_arc(ns.in_arc), _arc_num(ns._arc_num), _next_arc(0)
       {
         // The main parameters of the pivot rule
-        const double BLOCK_SIZE_FACTOR = 0.5;
+        const double BLOCK_SIZE_FACTOR = 2.0;
         const int MIN_BLOCK_SIZE = 10;
 
         _block_size = std::max( int(BLOCK_SIZE_FACTOR *
-                                    std::sqrt(double(_search_arc_num))),
+                                    std::sqrt(double(_arc_num))),
                                 MIN_BLOCK_SIZE );
       }
@@ -365,30 +395,31 @@
         Cost c, min = 0;
         int cnt = _block_size;
-        int e;
-        for (e = _next_arc; e < _search_arc_num; ++e) {
+        int e, min_arc = _next_arc;
+        for (e = _next_arc; e < _arc_num; ++e) {
           c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
           if (c < min) {
             min = c;
-            _in_arc = e;
+            min_arc = e;
           }
           if (--cnt == 0) {
-            if (min < 0) goto search_end;
+            if (min < 0) break;
             cnt = _block_size;
           }
         }
-        for (e = 0; e < _next_arc; ++e) {
-          c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
-          if (c < min) {
-            min = c;
-            _in_arc = e;
-          }
-          if (--cnt == 0) {
-            if (min < 0) goto search_end;
-            cnt = _block_size;
+        if (min == 0 || cnt > 0) {
+          for (e = 0; e < _next_arc; ++e) {
+            c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
+            if (c < min) {
+              min = c;
+              min_arc = e;
+            }
+            if (--cnt == 0) {
+              if (min < 0) break;
+              cnt = _block_size;
+            }
           }
         }
         if (min >= 0) return false;
-
-      search_end:
+        _in_arc = min_arc;
         _next_arc = e;
         return true;
@@ -410,5 +441,5 @@
       const CostVector &_pi;
       int &_in_arc;
-      int _search_arc_num;
+      int _arc_num;
 
       // Pivot rule data
@@ -424,9 +455,8 @@
         _source(ns._source), _target(ns._target),
         _cost(ns._cost), _state(ns._state), _pi(ns._pi),
-        _in_arc(ns.in_arc), _search_arc_num(ns._search_arc_num),
-        _next_arc(0)
+        _in_arc(ns.in_arc), _arc_num(ns._arc_num), _next_arc(0)
       {
         // The main parameters of the pivot rule
-        const double LIST_LENGTH_FACTOR = 0.25;
+        const double LIST_LENGTH_FACTOR = 1.0;
         const int MIN_LIST_LENGTH = 10;
         const double MINOR_LIMIT_FACTOR = 0.1;
@@ -434,5 +464,5 @@
 
         _list_length = std::max( int(LIST_LENGTH_FACTOR *
-                                     std::sqrt(double(_search_arc_num))),
+                                     std::sqrt(double(_arc_num))),
                                  MIN_LIST_LENGTH );
         _minor_limit = std::max( int(MINOR_LIMIT_FACTOR * _list_length),
@@ -445,5 +475,5 @@
       bool findEnteringArc() {
         Cost min, c;
-        int e;
+        int e, min_arc = _next_arc;
         if (_curr_length > 0 && _minor_count < _minor_limit) {
           // Minor iteration: select the best eligible arc from the
@@ -456,11 +486,14 @@
             if (c < min) {
               min = c;
-              _in_arc = e;
+              min_arc = e;
             }
-            else if (c >= 0) {
+            if (c >= 0) {
               _candidates[i--] = _candidates[--_curr_length];
             }
           }
-          if (min < 0) return true;
+          if (min < 0) {
+            _in_arc = min_arc;
+            return true;
+          }
         }
 
@@ -468,5 +501,5 @@
         min = 0;
         _curr_length = 0;
-        for (e = _next_arc; e < _search_arc_num; ++e) {
+        for (e = _next_arc; e < _arc_num; ++e) {
           c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
           if (c < 0) {
@@ -474,24 +507,25 @@
             if (c < min) {
               min = c;
-              _in_arc = e;
+              min_arc = e;
             }
-            if (_curr_length == _list_length) goto search_end;
-          }
-        }
-        for (e = 0; e < _next_arc; ++e) {
-          c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
-          if (c < 0) {
-            _candidates[_curr_length++] = e;
-            if (c < min) {
-              min = c;
-              _in_arc = e;
+            if (_curr_length == _list_length) break;
+          }
+        }
+        if (_curr_length < _list_length) {
+          for (e = 0; e < _next_arc; ++e) {
+            c = _state[e] * (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
+            if (c < 0) {
+              _candidates[_curr_length++] = e;
+              if (c < min) {
+                min = c;
+                min_arc = e;
+              }
+              if (_curr_length == _list_length) break;
             }
-            if (_curr_length == _list_length) goto search_end;
           }
         }
         if (_curr_length == 0) return false;
-      
-      search_end:        
         _minor_count = 1;
+        _in_arc = min_arc;
         _next_arc = e;
         return true;
@@ -513,5 +547,5 @@
       const CostVector &_pi;
       int &_in_arc;
-      int _search_arc_num;
+      int _arc_num;
 
       // Pivot rule data
@@ -541,9 +575,9 @@
         _source(ns._source), _target(ns._target),
         _cost(ns._cost), _state(ns._state), _pi(ns._pi),
-        _in_arc(ns.in_arc), _search_arc_num(ns._search_arc_num),
-        _next_arc(0), _cand_cost(ns._search_arc_num), _sort_func(_cand_cost)
+        _in_arc(ns.in_arc), _arc_num(ns._arc_num),
+        _next_arc(0), _cand_cost(ns._arc_num), _sort_func(_cand_cost)
       {
         // The main parameters of the pivot rule
-        const double BLOCK_SIZE_FACTOR = 1.0;
+        const double BLOCK_SIZE_FACTOR = 1.5;
         const int MIN_BLOCK_SIZE = 10;
         const double HEAD_LENGTH_FACTOR = 0.1;
@@ -551,5 +585,5 @@
 
         _block_size = std::max( int(BLOCK_SIZE_FACTOR *
-                                    std::sqrt(double(_search_arc_num))),
+                                    std::sqrt(double(_arc_num))),
                                 MIN_BLOCK_SIZE );
         _head_length = std::max( int(HEAD_LENGTH_FACTOR * _block_size),
@@ -574,33 +608,37 @@
         // Extend the list
         int cnt = _block_size;
+        int last_arc = 0;
         int limit = _head_length;
 
-        for (e = _next_arc; e < _search_arc_num; ++e) {
+        for (int e = _next_arc; e < _arc_num; ++e) {
           _cand_cost[e] = _state[e] *
             (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
           if (_cand_cost[e] < 0) {
             _candidates[_curr_length++] = e;
+            last_arc = e;
           }
           if (--cnt == 0) {
-            if (_curr_length > limit) goto search_end;
+            if (_curr_length > limit) break;
             limit = 0;
             cnt = _block_size;
           }
         }
-        for (e = 0; e < _next_arc; ++e) {
-          _cand_cost[e] = _state[e] *
-            (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
-          if (_cand_cost[e] < 0) {
-            _candidates[_curr_length++] = e;
-          }
-          if (--cnt == 0) {
-            if (_curr_length > limit) goto search_end;
-            limit = 0;
-            cnt = _block_size;
+        if (_curr_length <= limit) {
+          for (int e = 0; e < _next_arc; ++e) {
+            _cand_cost[e] = _state[e] *
+              (_cost[e] + _pi[_source[e]] - _pi[_target[e]]);
+            if (_cand_cost[e] < 0) {
+              _candidates[_curr_length++] = e;
+              last_arc = e;
+            }
+            if (--cnt == 0) {
+              if (_curr_length > limit) break;
+              limit = 0;
+              cnt = _block_size;
+            }
           }
         }
         if (_curr_length == 0) return false;
-        
-      search_end:
+        _next_arc = last_arc + 1;
 
         // Make heap of the candidate list (approximating a partial sort)
@@ -610,5 +648,4 @@
         // Pop the first element of the heap
         _in_arc = _candidates[0];
-        _next_arc = e;
         pop_heap( _candidates.begin(), _candidates.begin() + _curr_length,
                   _sort_func );
@@ -626,9 +663,5 @@
     ///
     /// \param graph The digraph the algorithm runs on.
-    /// \param arc_mixing Indicate if the arcs have to be stored in a
-    /// mixed order in the internal data structure. 
-    /// In special cases, it could lead to better overall performance,
-    /// but it is usually slower. Therefore it is disabled by default.
-    NetworkSimplex(const GR& graph, bool arc_mixing = false) :
+    NetworkSimplex(const GR& graph) :
       _graph(graph), _node_id(graph), _arc_id(graph),
       INF(std::numeric_limits<Value>::has_infinity ?
@@ -646,15 +679,15 @@
       _arc_num = countArcs(_graph);
       int all_node_num = _node_num + 1;
-      int max_arc_num = _arc_num + 2 * _node_num;
-
-      _source.resize(max_arc_num);
-      _target.resize(max_arc_num);
-
-      _lower.resize(_arc_num);
-      _upper.resize(_arc_num);
-      _cap.resize(max_arc_num);
-      _cost.resize(max_arc_num);
+      int all_arc_num = _arc_num + _node_num;
+
+      _source.resize(all_arc_num);
+      _target.resize(all_arc_num);
+
+      _lower.resize(all_arc_num);
+      _upper.resize(all_arc_num);
+      _cap.resize(all_arc_num);
+      _cost.resize(all_arc_num);
       _supply.resize(all_node_num);
-      _flow.resize(max_arc_num);
+      _flow.resize(all_arc_num);
       _pi.resize(all_node_num);
 
@@ -666,33 +699,31 @@
       _succ_num.resize(all_node_num);
       _last_succ.resize(all_node_num);
-      _state.resize(max_arc_num);
-
-      // Copy the graph
+      _state.resize(all_arc_num);
+
+      // Copy the graph (store the arcs in a mixed order)
       int i = 0;
       for (NodeIt n(_graph); n != INVALID; ++n, ++i) {
         _node_id[n] = i;
       }
-      if (arc_mixing) {
-        // Store the arcs in a mixed order
-        int k = std::max(int(std::sqrt(double(_arc_num))), 10);
-        int i = 0, j = 0;
-        for (ArcIt a(_graph); a != INVALID; ++a) {
-          _arc_id[a] = i;
-          _source[i] = _node_id[_graph.source(a)];
-          _target[i] = _node_id[_graph.target(a)];
-          if ((i += k) >= _arc_num) i = ++j;
-        }
-      } else {
-        // Store the arcs in the original order
-        int i = 0;
-        for (ArcIt a(_graph); a != INVALID; ++a, ++i) {
-          _arc_id[a] = i;
-          _source[i] = _node_id[_graph.source(a)];
-          _target[i] = _node_id[_graph.target(a)];
-        }
+      int k = std::max(int(std::sqrt(double(_arc_num))), 10);
+      i = 0;
+      for (ArcIt a(_graph); a != INVALID; ++a) {
+        _arc_id[a] = i;
+        _source[i] = _node_id[_graph.source(a)];
+        _target[i] = _node_id[_graph.target(a)];
+        if ((i += k) >= _arc_num) i = (i % k) + 1;
       }
       
-      // Reset parameters
-      reset();
+      // Initialize maps
+      for (int i = 0; i != _node_num; ++i) {
+        _supply[i] = 0;
+      }
+      for (int i = 0; i != _arc_num; ++i) {
+        _lower[i] = 0;
+        _upper[i] = INF;
+        _cost[i] = 1;
+      }
+      _have_lower = false;
+      _stype = GEQ;
     }
 
@@ -767,4 +798,5 @@
     /// If neither this function nor \ref stSupply() is used before
     /// calling \ref run(), the supply of each node will be set to zero.
+    /// (It makes sense only if non-zero lower bounds are given.)
     ///
     /// \param map A node map storing the supply values.
@@ -787,4 +819,5 @@
     /// If neither this function nor \ref supplyMap() is used before
     /// calling \ref run(), the supply of each node will be set to zero.
+    /// (It makes sense only if non-zero lower bounds are given.)
     ///
     /// Using this function has the same effect as using \ref supplyMap()
@@ -813,5 +846,5 @@
     /// type will be used.
     ///
-    /// For more information, see \ref SupplyType.
+    /// For more information see \ref SupplyType.
     ///
     /// \return <tt>(*this)</tt>
@@ -845,9 +878,9 @@
     /// \ref reset() is called, thus only the modified parameters
     /// have to be set again. See \ref reset() for examples.
-    /// However, the underlying digraph must not be modified after this
+    /// However the underlying digraph must not be modified after this
     /// class have been constructed, since it copies and extends the graph.
     ///
     /// \param pivot_rule The pivot rule that will be used during the
-    /// algorithm. For more information, see \ref PivotRule.
+    /// algorithm. For more information see \ref PivotRule.
     ///
     /// \return \c INFEASIBLE if no feasible flow exists,
@@ -874,5 +907,5 @@
     /// used, all the parameters given before are kept for the next
     /// \ref run() call.
-    /// However, the underlying digraph must not be modified after this
+    /// However the underlying digraph must not be modified after this
     /// class have been constructed, since it copies and extends the graph.
     ///
@@ -1037,5 +1070,5 @@
       Cost ART_COST;
       if (std::numeric_limits<Cost>::is_exact) {
-        ART_COST = std::numeric_limits<Cost>::max() / 2 + 1;
+        ART_COST = std::numeric_limits<Cost>::max() / 4 + 1;
       } else {
         ART_COST = std::numeric_limits<Cost>::min();
@@ -1061,118 +1094,26 @@
       _last_succ[_root] = _root - 1;
       _supply[_root] = -_sum_supply;
-      _pi[_root] = 0;
+      _pi[_root] = _sum_supply < 0 ? -ART_COST : ART_COST;
 
       // Add artificial arcs and initialize the spanning tree data structure
-      if (_sum_supply == 0) {
-        // EQ supply constraints
-        _search_arc_num = _arc_num;
-        _all_arc_num = _arc_num + _node_num;
-        for (int u = 0, e = _arc_num; u != _node_num; ++u, ++e) {
-          _parent[u] = _root;
-          _pred[u] = e;
-          _thread[u] = u + 1;
-          _rev_thread[u + 1] = u;
-          _succ_num[u] = 1;
-          _last_succ[u] = u;
-          _cap[e] = INF;
-          _state[e] = STATE_TREE;
-          if (_supply[u] >= 0) {
-            _forward[u] = true;
-            _pi[u] = 0;
-            _source[e] = u;
-            _target[e] = _root;
-            _flow[e] = _supply[u];
-            _cost[e] = 0;
-          } else {
-            _forward[u] = false;
-            _pi[u] = ART_COST;
-            _source[e] = _root;
-            _target[e] = u;
-            _flow[e] = -_supply[u];
-            _cost[e] = ART_COST;
-          }
-        }
-      }
-      else if (_sum_supply > 0) {
-        // LEQ supply constraints
-        _search_arc_num = _arc_num + _node_num;
-        int f = _arc_num + _node_num;
-        for (int u = 0, e = _arc_num; u != _node_num; ++u, ++e) {
-          _parent[u] = _root;
-          _thread[u] = u + 1;
-          _rev_thread[u + 1] = u;
-          _succ_num[u] = 1;
-          _last_succ[u] = u;
-          if (_supply[u] >= 0) {
-            _forward[u] = true;
-            _pi[u] = 0;
-            _pred[u] = e;
-            _source[e] = u;
-            _target[e] = _root;
-            _cap[e] = INF;
-            _flow[e] = _supply[u];
-            _cost[e] = 0;
-            _state[e] = STATE_TREE;
-          } else {
-            _forward[u] = false;
-            _pi[u] = ART_COST;
-            _pred[u] = f;
-            _source[f] = _root;
-            _target[f] = u;
-            _cap[f] = INF;
-            _flow[f] = -_supply[u];
-            _cost[f] = ART_COST;
-            _state[f] = STATE_TREE;
-            _source[e] = u;
-            _target[e] = _root;
-            _cap[e] = INF;
-            _flow[e] = 0;
-            _cost[e] = 0;
-            _state[e] = STATE_LOWER;
-            ++f;
-          }
-        }
-        _all_arc_num = f;
-      }
-      else {
-        // GEQ supply constraints
-        _search_arc_num = _arc_num + _node_num;
-        int f = _arc_num + _node_num;
-        for (int u = 0, e = _arc_num; u != _node_num; ++u, ++e) {
-          _parent[u] = _root;
-          _thread[u] = u + 1;
-          _rev_thread[u + 1] = u;
-          _succ_num[u] = 1;
-          _last_succ[u] = u;
-          if (_supply[u] <= 0) {
-            _forward[u] = false;
-            _pi[u] = 0;
-            _pred[u] = e;
-            _source[e] = _root;
-            _target[e] = u;
-            _cap[e] = INF;
-            _flow[e] = -_supply[u];
-            _cost[e] = 0;
-            _state[e] = STATE_TREE;
-          } else {
-            _forward[u] = true;
-            _pi[u] = -ART_COST;
-            _pred[u] = f;
-            _source[f] = u;
-            _target[f] = _root;
-            _cap[f] = INF;
-            _flow[f] = _supply[u];
-            _state[f] = STATE_TREE;
-            _cost[f] = ART_COST;
-            _source[e] = _root;
-            _target[e] = u;
-            _cap[e] = INF;
-            _flow[e] = 0;
-            _cost[e] = 0;
-            _state[e] = STATE_LOWER;
-            ++f;
-          }
-        }
-        _all_arc_num = f;
+      for (int u = 0, e = _arc_num; u != _node_num; ++u, ++e) {
+        _parent[u] = _root;
+        _pred[u] = e;
+        _thread[u] = u + 1;
+        _rev_thread[u + 1] = u;
+        _succ_num[u] = 1;
+        _last_succ[u] = u;
+        _cost[e] = ART_COST;
+        _cap[e] = INF;
+        _state[e] = STATE_TREE;
+        if (_supply[u] > 0 || (_supply[u] == 0 && _sum_supply <= 0)) {
+          _flow[e] = _supply[u];
+          _forward[u] = true;
+          _pi[u] = -ART_COST + _pi[_root];
+        } else {
+          _flow[e] = -_supply[u];
+          _forward[u] = false;
+          _pi[u] = ART_COST + _pi[_root];
+        }
       }
 
@@ -1434,6 +1375,18 @@
       
       // Check feasibility
-      for (int e = _search_arc_num; e != _all_arc_num; ++e) {
-        if (_flow[e] != 0) return INFEASIBLE;
+      if (_sum_supply < 0) {
+        for (int u = 0, e = _arc_num; u != _node_num; ++u, ++e) {
+          if (_supply[u] >= 0 && _flow[e] != 0) return INFEASIBLE;
+        }
+      }
+      else if (_sum_supply > 0) {
+        for (int u = 0, e = _arc_num; u != _node_num; ++u, ++e) {
+          if (_supply[u] <= 0 && _flow[e] != 0) return INFEASIBLE;
+        }
+      }
+      else {
+        for (int u = 0, e = _arc_num; u != _node_num; ++u, ++e) {
+          if (_flow[e] != 0) return INFEASIBLE;
+        }
       }
 
@@ -1449,28 +1402,4 @@
         }
       }
-      
-      // Shift potentials to meet the requirements of the GEQ/LEQ type
-      // optimality conditions
-      if (_sum_supply == 0) {
-        if (_stype == GEQ) {
-          Cost max_pot = std::numeric_limits<Cost>::min();
-          for (int i = 0; i != _node_num; ++i) {
-            if (_pi[i] > max_pot) max_pot = _pi[i];
-          }
-          if (max_pot > 0) {
-            for (int i = 0; i != _node_num; ++i)
-              _pi[i] -= max_pot;
-          }
-        } else {
-          Cost min_pot = std::numeric_limits<Cost>::max();
-          for (int i = 0; i != _node_num; ++i) {
-            if (_pi[i] < min_pot) min_pot = _pi[i];
-          }
-          if (min_pot < 0) {
-            for (int i = 0; i != _node_num; ++i)
-              _pi[i] -= min_pot;
-          }
-        }
-      }
 
       return OPTIMAL;
